Subject: Re: [PATCH] commit-graph: warn about incompatibilities only when trying to write

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Sun, 28 Feb 2021 17:20:15 +0100

On Fri, Feb 26 2021, Junio C Hamano wrote:

> Ævar Arnfjörð Bjarmason <[email-masked]> writes:
>
>> On Fri, Feb 26 2021, Johannes Schindelin via GitGitGadget wrote:
>>
>>> From: Johannes Schindelin <[email-masked]>
>>>
>>> In c85eec7fc37 (commit-graph: when incompatible with graphs, indicate
>>> why, 2021-02-11), we started warning the user if they tried to write a
>>> commit-graph in a shallow repository, or one containing replace objects.
>>>
>>> However, this patch was a bit overzealous, as Git now _also_ warns when
>>> merely checking whether there _is_ a usable commit graph, not only when
>>> writing one.
>>>
>>> Let's suppress that warning unless we want to write a commit-graph.
>>
>> Ah, so that's what it's for, as I suspected :) Unfortunately...
>> ...
>> ...doing this will cause "git gc --auto" to run into persistent
>> warnings. See a WIP patch-on-top in [1] below...
>
> Thanks for an input.
>
>> diff --git a/builtin/gc.c b/builtin/gc.c
>> index 64f2b52d6e2..9109898eacb 100644
>> --- a/builtin/gc.c
>> +++ b/builtin/gc.c
>> @@ -593,7 +593,7 @@ int cmd_gc(int argc, const char **argv, const char *prefix)
>>  		/*
>>  		 * Auto-gc should be least intrusive as possible.
>>  		 */
>> -		if (!need_to_gc())
>> +		if (0 && !need_to_gc())
>>  			return 0;
>
> Leftover debugging cruft?

Yeah, see the "Obviously needs amending" later in my E-Mail.

>> -			if (!quiet)
>> +			if (flags & COMMIT_GRAPH_WRITE_WARNINGS)
>>  				warning(_("repository contains replace "
>>  					  "objects; skipping commit-graph"));
>
> I would have expected the code would arrange to make the bit cleared
> in the "flags" that would be passed around to the next call that
> inspects the same bit, so that we won't need to see repeated
> warning()s, but I do not see where it is done.

Right, we could do that, but I think the path down my "test_line_count =
1" is more useful.

I.e. it's pretty easy to reason about us not calling
write_commit_graph() twice in the same process, so I don't think such
flag clearing is needed.

But the case the user cares about is getting this warning twice when
they invoke git, but we spawn two processes.

> I am tempted to say that we should revert c85eec7f (commit-graph:
> when incompatible with graphs, indicate why, 2021-02-11) for the
> upcoming release.  That would give us enough time to come up with
> and cook the solution in 'next' in the meantime.

That's probably sensible.

Also, I noticed that we went through this whole saga in the past, see
25575015ca (repack: silence warnings when auto-enabled bitmaps cannot be
built, 2019-07-31), including breaking background gc.